VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Form1 
   Caption         =   "BC8150"
   ClientHeight    =   5205
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   6390
   LinkTopic       =   "Form1"
   ScaleHeight     =   5205
   ScaleWidth      =   6390
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdEnd 
      Caption         =   "&End"
      Height          =   375
      Left            =   5040
      TabIndex        =   3
      Top             =   3720
      Width           =   1215
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Height          =   375
      Left            =   5040
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   5400
      Top             =   1920
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   5400
      Top             =   1440
   End
   Begin VB.Label Label2 
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "Read"
      Height          =   1935
      Left            =   120
      TabIndex        =   1
      Top             =   2160
      Width           =   4815
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "Write"
      Height          =   1935
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4815
   End
   Begin VB.Menu mnuCOM 
      Caption         =   "COM Port"
      Begin VB.Menu mnuBaudrate 
         Caption         =   "Baudrate"
         Begin VB.Menu mnu9600 
            Caption         =   "9600"
         End
         Begin VB.Menu mnu19200 
            Caption         =   "19200"
         End
         Begin VB.Menu mnu38400 
            Caption         =   "38400"
            Checked         =   -1  'True
         End
      End
      Begin VB.Menu mnuPort 
         Caption         =   "Port"
         Begin VB.Menu mnuPort1 
            Caption         =   "1"
            Checked         =   -1  'True
         End
         Begin VB.Menu mnuPort2 
            Caption         =   "2"
         End
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim lStartkennung As Long, lAnzahlPDOut As Long, lMessageId As Long
Dim lMultiPointAd As Long, lPDOut1 As Long, lPDOut2 As Long
Dim lChecksumme As Long

Dim szAusgabestring As String, szDummystring As String
Dim varBuffer As Variant
Dim Arr() As Byte
' Dieses Programm soll das Protokoll zwischen Buskoppler und PC erlutern.
' Das Programm schreibt alle 50ms das Muster 10101010 01010101 und addiert dann 1 darauf
' An den Ausgngen erscheint das Muster wenn die bertragung fehlerfrei verlief
' Es wird das Control MSComm fr den Datenaustausch mit der Hardware verwendet

Private Sub cmdEnd_Click()
    If MSComm1.PortOpen Then
        MSComm1.PortOpen = False
    End If
    End
End Sub

Private Sub cmdStart_Click()
   ' Hier wird der Timer fr einen zyklischen Aufruf gesetzt
If cmdStart.Caption = "Start" Then
       Timer1.Interval = 50    'in ms
       Timer1.Enabled = True   'Timer einschalten
       cmdStart.Caption = "Stop"
       mnuCOM.Enabled = False
    ' Open the serial port
    ' Anpassung auf einen anderen Port kann notwendig sein
    If mnuPort1.Checked Then
        MSComm1.CommPort = 1
        mnuPort1.Checked = True
        mnuPort2.Checked = False
    Else
        MSComm1.CommPort = 2
        mnuPort1.Checked = False
        mnuPort2.Checked = True
    End If
    
    If mnu38400.Checked Then
        MSComm1.Settings = "38400,E,8,1"
    ElseIf mnu19200.Checked Then
        MSComm1.Settings = "19200,E,8,1"
    Else
        MSComm1.Settings = "9600,E,8,1"
    End If
    Form1.Caption = "BC8150 " & MSComm1.Settings & " COM Port: " & MSComm1.CommPort
    MSComm1.PortOpen = True
    MSComm1.Output = szAusgabestring
Else
       Timer1.Enabled = False   'Timer einschalten
       cmdStart.Caption = "Start"
       mnuCOM.Enabled = True
       MSComm1.PortOpen = False
End If

End Sub

Private Sub Command1_Click()

End Sub

Private Sub Form_Load()
    
    Dim n As Integer
    Dim szAusgabeText As String

    ' Ein Telegramm Zusammenstellen fr einen BK8x00 mit
    ' 2 bis 16 digitalen Eingngen und
    ' 2 bis 16 digitalen Ausgngen
    lStartkennung = &H50     'Startkennung "P"; hex50
    lAnzahlPDOut = 8         'Anzahl der zu bertragenen Worte
    lMessageId = 0          'Beliebige ID
    lMultiPointAd = 11       'Adresse auf dem Buskoppler, richtige Einstellung!!!
    lPDOut1 = &HAA&          'Ausgabebyte 1
    lPDOut2 = &H55&          'Ausgabebyte 2
                        'wenn die Ausgabe mehr Worte enthlt,
                        'werden hier weitere Bytes
                        'eingefgt .... (und Anzahl anpassen)
    
    ' Berechnung der Checksumme
    lChecksumme = lStartkennung + lAnzahlPDOut + lMessageId + lMultiPointAd + lPDOut1 + lPDOut2
    lChecksumme = lChecksumme And &HFF& 'auf ein Byte maskieren


    'Hier wird ein String fr die Ausgabe zusammengestellt
    szAusgabestring = Chr$(lStartkennung)             'die Funktion Chr$() sorgt fr das
    szAusgabestring = szAusgabestring & Chr$(lAnzahlPDOut) 'Zusammenstellen der Bytes und
    szAusgabestring = szAusgabestring & Chr$(lMessageId)   'nicht der Ziffern (VBasic-Sache)
    szAusgabestring = szAusgabestring & Chr$(lMultiPointAd)
    szAusgabestring = szAusgabestring & Chr$(lPDOut1)
    szAusgabestring = szAusgabestring & Chr$(lPDOut2)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(0)
    szAusgabestring = szAusgabestring & Chr$(lChecksumme)
    
 
    MSComm1.InputMode = comInputModeBinary 'spezifisch fr dieses Control


    
    'hier folgt nur die Ausgabe, Sie ist fr das Protokoll ohne Bedeutung
    'der erzeugte String Ausgabestring wird fr die Ausgabe (Kontrolle) in Hex-Werte
    'zerlegt und als Ausgabestring zusammengestellt
    For n = 1 To Len(szAusgabestring)
        szAusgabeText = szAusgabeText & Hex$(Asc(Mid$(szAusgabestring, n, 1))) & "  "
    Next n
    
    'die Ausgabe des Strings auf den Monitor
    Label1.Caption = "Das wird sendet (in HEX):" & vbCr & "-" & szAusgabeText & "- "
    '-------
    
    
    
    
    'die Ausgabe des Strings auf der Seriellen Schnittstelle
    '
    '!!! Zu beachten ist hier, die automatische Bauratenerkennung des Buskopplers
    'bentigt u.U. einige Bytes um sich auf die Baurate einzustellen.
    'Das erste Telegramm zeigt dann noch keine Wirkung!!!!
    'Deshalb wiederholter Aufruf in der Timerroutine, siehe weiter unten
    'in der Timer1 Routine
    
 

 

End Sub


Private Sub mnu19200_Click()
        mnu38400.Checked = False
        mnu19200.Checked = True
        mnu9600.Checked = False
End Sub

Private Sub mnu38400_Click()
        mnu38400.Checked = True
        mnu19200.Checked = False
        mnu9600.Checked = False
End Sub

Private Sub mnu9600_Click()
        mnu38400.Checked = False
        mnu19200.Checked = False
        mnu9600.Checked = True
End Sub

Private Sub mnuPort1_Click()
mnuPort1.Checked = True
mnuPort2.Checked = False


End Sub
Private Sub mnuPort2_Click()
mnuPort1.Checked = False
mnuPort2.Checked = True


End Sub

Private Sub Timer1_Timer()

    Dim lInBufferCount As Long
    Dim szAusgabeText As String
    Dim n As Integer
'die zyklische Ausgabe des Strings auf die Serielle COMx
'-------------------------------------------------------------------
'Anmerkung: nach 1 Sekunde schlgt auf dem Buskoppler ein Watchdog zu,
'wenn keine weiteren Telegramme einlaufen -> die Ausgnge fallen ab
    If lPDOut1 >= 254 Then  'Daten werden um Eins erhht bis  max 254
        lPDOut1 = 0
    End If
    If lPDOut2 >= 254 Then
        lPDOut2 = 0
    End If
    lPDOut1 = lPDOut1 + 1   'data count up +1
    lPDOut2 = lPDOut2 + 1   'data count up +1
    lChecksumme = lStartkennung + lAnzahlPDOut + lMessageId + lMultiPointAd + lPDOut1 + lPDOut2
    lChecksumme = lChecksumme And &HFF&
    szAusgabestring = Chr$(lStartkennung)                       'die Funktion Chr$() sorgt fr das
    szAusgabestring = szAusgabestring & Chr$(lAnzahlPDOut)      'Zusammenstellen der Bytes und
    szAusgabestring = szAusgabestring & Chr$(lMessageId)        'nicht der Ziffern (VBasic-Sache)
    szAusgabestring = szAusgabestring & Chr$(lMultiPointAd)     'address from the BC8150
    szAusgabestring = szAusgabestring & Chr$(lPDOut1)           'High byte word 0
    szAusgabestring = szAusgabestring & Chr$(lPDOut2)           'High byte word 0
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 1
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 1
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 2
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 2
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 3
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 3
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 4
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 4
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 5
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 5
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 6
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 6
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 7
    szAusgabestring = szAusgabestring & Chr$(0)                 'High byte word 7
    szAusgabestring = szAusgabestring & Chr$(lChecksumme)
    For n = 1 To Len(szAusgabestring)
        szAusgabeText = szAusgabeText & Hex$(Asc(Mid$(szAusgabestring, n, 1))) & "  "
    Next n
    Label1.Caption = "Das wird sendet (in HEX):" & vbCr & "-" & szAusgabeText & "- "
    
    
    ' Dieser Programmteil liest die Daten aus dem ReceiveBuffer des
    ' "MSComm1 Controls" und gibt sie auf dem Monitor aus.
    '-------------------------------------------------------------------
    lInBufferCount = MSComm1.InBufferCount       'Lnge des empfangenen Blocks
    
    varBuffer = MSComm1.Input                      'Zwischenspeicher (BasicSache)
    Arr = varBuffer                                'bergabe in ein Array
    

    'Darstellung im Hex-Format fr die Ausgabe
    szAusgabeText = ""
    For n = 0 To lInBufferCount - 1
        szAusgabeText = szAusgabeText & Hex$((Arr(n))) & " "
    Next n
    Label2.Caption = "Ausgabe der empfangenen Daten:" & vbCr & "InBufferCount = " & lInBufferCount & vbCr
    Label2.Caption = Label2.Caption & "InBufferCount nach dem Lesen = " & MSComm1.InBufferCount & vbCr
    Label2.Caption = Label2.Caption & " Input =  " & szAusgabeText & vbCr & vbCr
    ' Ausgabe der Daten
    '---------------------------------------------------------------------
    MSComm1.Output = szAusgabestring
    '---------------------------------------------------------------------
End Sub



Private Sub MSComm1_OnComm()
    ' dieser Programmteil wird aufgerufen, wenn ein Ereignis aufgetreten ist

    Select Case MSComm1.CommEvent
        ' Dieser Teil ist zum Anzeigen der bertragungsfehler die das Control
        ' MSComm erkennt, es lst ein EVENT aus. Hier wird der entsprechende Fehler
        ' oder das EVENT angezeigt. Fr die Funktion ist das ohne Bedeutung. Es
        ' dient hier nur der schnelleren Entwicklung
        '-------------------------------------------------------------------------
    
        ' Diese Programmbeispiel ist der Hilfe entnommen:
        ' Handle each event or error by placing
        ' code below each case statement
        ' Errors
            Case comEventBreak  ' A Break was received.
                Label1.Caption = "A Break was received "
            Case comEventCDTO   ' CD (RLSD) Timeout.
                Label1.Caption = "CD (RLSD) Timeout "
            Case comEventCTSTO  ' CTS Timeout.
                Label1.Caption = "CTS Timeoutt "
            Case comEventDSRTO  ' DSR Timeout.
                Label1.Caption = "DSR Timeout "
            Case comEventFrame  ' Framing Error
                Label1.Caption = "Framing Error "
            Case comEventOverrun    ' Data Lost.
                Label1.Caption = "Data Lost "
            Case comEventRxOver ' Receive buffer overflow.
                Label1.Caption = "Receive buffer overflow "
            Case comEventRxParity   ' Parity Error.
                Label1.Caption = "Parity Error "
    
    Case comEventTxFull ' Transmit buffer full.
            Label1.Caption = "Transmit buffer full "
            Case comEventDCB    ' Unexpected error retrieving DCB]
                Label1.Caption = "Unexpected error retrieving DCB] "
    
        ' Events
            Case comEvCD    ' Change in the CD line.
                Label1.Caption = "Change in the CD line "
            Case comEvCTS   ' Change in the CTS line.
                Label1.Caption = "Change in the CTS line "
            Case comEvDSR   ' Change in the DSR line.
                Label1.Caption = "Change in the DSR line "
            Case comEvRing  ' Change in the Ring Indicator.
                Label1.Caption = "Change in the Ring Indicator "
            Case comEvReceive   ' Received RThreshold # of
                                    ' chars.
                Label1.Caption = "Received RThreshold # of chars "
            Case comEvSend  ' There are SThreshold number of
                                ' characters in the transmit
                                ' buffer.
                Label1.Caption = "There are SThreshold number of characters in the transmit buffer "
    
    
    Case comEvEOF   ' An EOF charater was found in the input stream
        Label1.Caption = "An EOF charater was found in the input stream "
    End Select

End Sub


Private Sub Form_Unload(Cancel As Integer)
    'mit dem Ende des Programms wird auch die Schnittstelle geschlossen
    If MSComm1.PortOpen Then
      MSComm1.PortOpen = False
    End If
End Sub

